package com.lframework.xingyun.sc.entity;

import com.alibaba.excel.annotation.format.DateTimeFormat;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.lframework.starter.common.constants.StringPool;
import com.lframework.starter.web.components.validation.IsEnum;
import com.lframework.starter.web.dto.BaseDto;
import com.lframework.starter.web.entity.BaseEntity;
import com.lframework.xingyun.sc.enums.SaleOrderIsLease;
import com.lframework.xingyun.sc.enums.SaleOrderPurchaseStatus;
import com.lframework.xingyun.sc.enums.SaleOrderStatus;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Date;

import lombok.Data;

/**
 * <p>
 *
 * </p>
 *
 * @author zmj
 * @since 2021-10-21
 */
@Data
@TableName("tbl_sale_order")
public class SaleOrder extends BaseEntity implements BaseDto {

  private static final long serialVersionUID = 1L;

  /**
   * ID
   */
  private String id;

  /**
   * 单号
   */
  private String code;

  /**
   * 仓库ID
   */
  private String scId;

  /**
   * 客户ID
   */
  private String customerId;

  /**
   * 销售员ID
   */
  private String salerId;

  /**
   * 销售数量
   */
  private Integer totalNum;

  /**
   * 赠品数量
   */
  private Integer totalGiftNum;

  /**
   * 销售金额
   */
  private BigDecimal totalAmount;

  /**
   * 备注
   */
  private String description;

  /**
   * 创建人ID 新增时赋值
   */
  @TableField(fill = FieldFill.INSERT)
  private String createById;

  /**
   * 创建人 新增时赋值
   */
  @TableField(fill = FieldFill.INSERT)
  private String createBy;

  /**
   * 创建时间 新增时赋值
   */
  @TableField(fill = FieldFill.INSERT)
  private LocalDateTime createTime;

  /**
   * 修改人 新增和修改时赋值
   */
  @TableField(fill = FieldFill.INSERT_UPDATE)
  private String updateBy;

  /**
   * 修改人ID 新增和修改时赋值
   */
  @TableField(fill = FieldFill.INSERT_UPDATE)
  private String updateById;

  /**
   * 修改时间 新增和修改时赋值
   */
  @TableField(fill = FieldFill.INSERT_UPDATE)
  private LocalDateTime updateTime;

  /**
   * 审核人
   */
  private String approveBy;

  /**
   * 审核时间
   */
  private LocalDateTime approveTime;

  /**
   * 状态
   */
  private SaleOrderStatus status;

  /**
   * 拒绝原因
   */
  private String refuseReason;

  /**
   * 本单利润
   */
  private BigDecimal thisOrderProfit;

  /**
   * 客户费用
   */
  private BigDecimal customMoney;

  /**
   * 采购价
   */
  private BigDecimal purchaseDecimal;

  /**
   * 采购总价
   */
  private BigDecimal totalPurchasePrice;

  /**
   * 运费
   */
  private BigDecimal shippingFee;

  /**
   * 是否租赁订单
   */
  private Integer isLease;


  /**
   * 采购状态，0未采购、2完成采购、3部分采购
   */
 // @IsEnum(message = "格式不正确！", enumClass = SaleOrderPurchaseStatus.class)
  private Integer purchaseStatus;

  /**
   * 租赁起始日期
   */
  @DateTimeFormat(StringPool.DATE_PATTERN)
  @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
  private LocalDateTime leaseStartTime;

  /**
   * 租赁结束日期
   */
  @DateTimeFormat(StringPool.DATE_PATTERN)
  @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
  private LocalDateTime leaseEndTime;


}
