package com.lframework.xingyun.sc.vo.chart;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.lframework.xingyun.sc.entity.SaleOrderDetail;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Data
public class SaleOrderVo {

    private String id;

    /**
     * 单号
     */
    private String code;

    /**
     * 仓库ID
     */
    private String scId;

    /**
     * 客户ID
     */
    private String customerId;

    /**
     * 销售员ID
     */
    private String salerId;

    /**
     * 销售员
     */
    private String salerName;

    /**
     * 销售数量
     */
    private Integer totalNum;

    /**
     * 赠品数量
     */
    private Integer totalGiftNum;

    /**
     * 销售金额
     */
    private BigDecimal totalAmount;

    /**
     * 备注
     */
    private String description;


    private String createById;

    /**
     * 创建人 新增时赋值
     */

    private String createBy;


    private Date createTime;

    /**
     * 修改人 新增和修改时赋值
     */
    private String updateBy;

    /**
     * 修改人ID 新增和修改时赋值
     */

    private String updateById;

    /**
     * 修改时间 新增和修改时赋值
     */

    private Date updateTime;

    /**
     * 审核人
     */
    private String approveBy;

    /**
     * 审核时间
     */
    private Date approveTime;

    /**
     * 拒绝原因
     */
    private String refuseReason;

    /**
     * 本单利润
     */
    private BigDecimal thisOrderProfit;

    /**
     * 客户费用
     */
    private BigDecimal customMoney;

    /**
     * 采购价
     */
    private BigDecimal purchaseDecimal;

    /**
     * 采购总价
     */
    private BigDecimal totalPurchasePrice;

    /**
     * 运费
     */
    private BigDecimal shippingFee;

    /**
     * 是否租赁订单
     */
    private Integer isLease;


    private Integer purchaseStatus;

    /**
     * 租赁起始日期
     */

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date leaseStartTime;

    /**
     * 租赁结束日期
     */

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date leaseEndTime;

    @ApiModelProperty(value = "详情")
    private List<SaleOrderDetail> saleOrderDetailList;
}
